var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var isNumeric_1 = require('../util/isNumeric');
var Scheduler_1 = require('../Scheduler');
var Observable_1 = require('../Observable');
var TimerObservable = (function (_super) {
    __extends(TimerObservable, _super);
    function TimerObservable(dueTime, period, scheduler) {
        if (dueTime === void 0) { dueTime = 0; }
        _super.call(this);
        this.dueTime = dueTime;
        this.period = period;
        this.scheduler = scheduler;
        if (isNumeric_1.default(period)) {
            this._period = Number(period) < 1 && 1 || Number(period);
        }
        else if (period && typeof period.schedule === "function") {
            scheduler = period;
        }
        if (!scheduler || typeof scheduler.schedule !== "function") {
            scheduler = Scheduler_1.default.nextTick;
        }
        this.scheduler = scheduler;
    }
    TimerObservable.create = function (dueTime, period, scheduler) {
        if (dueTime === void 0) { dueTime = 0; }
        return new TimerObservable(dueTime, period, scheduler);
    };
    TimerObservable.dispatch = function (state) {
        var index = state.index, period = state.period, subscriber = state.subscriber;
        var action = this;
        subscriber.next(index);
        if (typeof period === "undefined") {
            subscriber.complete();
            return;
        }
        else if (subscriber.isUnsubscribed) {
            return;
        }
        if (typeof action.delay === 'undefined') {
            action.add(action.scheduler.schedule(period, {
                index: index + 1, period: period, subscriber: subscriber
            }, TimerObservable.dispatch));
        }
        else {
            state.index = index + 1;
            action.schedule(state);
        }
    };
    TimerObservable.prototype._subscribe = function (subscriber) {
        var index = 0;
        var period = this._period;
        var dueTime = this.dueTime;
        var scheduler = this.scheduler;
        subscriber.add(scheduler.schedule(dueTime, {
            index: index, period: period, subscriber: subscriber
        }, TimerObservable.dispatch));
    };
    return TimerObservable;
})(Observable_1.default);
exports.default = TimerObservable;
