import Operator from '../Operator';
import Observer from '../Observer';
import Observable from '../Observable';
import { ZipSubscriber, ZipInnerSubscriber } from './zip';
export default function combineLatest<T, R>(...xs: (Observable<any> | ((...values: Array<any>) => R))[]): Observable<{}>;
export declare class CombineLatestOperator<T, R> extends Operator<T, R> {
    project: (...values: Array<any>) => R;
    constructor(project?: (...values: Array<any>) => R);
    call(observer: Observer<R>): Observer<T>;
}
export declare class CombineLatestSubscriber<T, R> extends ZipSubscriber<T, R> {
    project: (...values: Array<any>) => R;
    constructor(destination: Observer<R>, project?: (...values: Array<any>) => R);
    _subscribeInner(observable: any, values: any, index: any, total: any): any;
    _innerComplete(innerSubscriber: any): void;
}
export declare class CombineLatestInnerSubscriber<T, R> extends ZipInnerSubscriber<T, R> {
    constructor(parent: ZipSubscriber<T, R>, values: any, index: number, total: number);
    _next(x: any): void;
}
