var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Operator_1 = require('../Operator');
var Subscriber_1 = require('../Subscriber');
var Subscription_1 = require('../Subscription');
var bindCallback_1 = require('../util/bindCallback');
function _finally(finallySelector, thisArg) {
    return this.lift(new FinallyOperator(thisArg ?
        bindCallback_1.default(finallySelector, thisArg, 2) :
        finallySelector));
}
exports.default = _finally;
var FinallyOperator = (function (_super) {
    __extends(FinallyOperator, _super);
    function FinallyOperator(finallySelector) {
        _super.call(this);
        this.finallySelector = finallySelector;
    }
    FinallyOperator.prototype.call = function (observer) {
        return new FinallySubscriber(observer, this.finallySelector);
    };
    return FinallyOperator;
})(Operator_1.default);
exports.FinallyOperator = FinallyOperator;
var FinallySubscriber = (function (_super) {
    __extends(FinallySubscriber, _super);
    function FinallySubscriber(destination, finallySelector) {
        _super.call(this, destination);
        this.add(new Subscription_1.default(finallySelector));
    }
    return FinallySubscriber;
})(Subscriber_1.default);
exports.FinallySubscriber = FinallySubscriber;
