import Operator from '../Operator';
import Observer from '../Observer';
import Observable from '../Observable';
import Subscriber from '../Subscriber';
export default function merge(scheduler?: any, concurrent?: any, ...observables: Observable<any>[]): Observable<{}>;
export declare class MergeOperator<T, R> extends Operator<T, R> {
    concurrent: number;
    constructor(concurrent?: number);
    call(observer: Observer<R>): Observer<T>;
}
export declare class MergeSubscriber<T, R> extends Subscriber<T> {
    count: number;
    active: number;
    stopped: boolean;
    buffer: Observable<any>[];
    concurrent: number;
    constructor(destination: Observer<R>, concurrent: number);
    _next(value: any): void;
    _complete(): void;
    _unsubscribe(): void;
    _project(value: any, index: any): any;
    _buffer(value: any): void;
    _subscribeInner(observable: any, value: any, index: any): any;
    _innerComplete(): void;
}
export declare class MergeInnerSubscriber<T, R> extends Subscriber<T> {
    parent: MergeSubscriber<T, R>;
    constructor(parent: MergeSubscriber<T, R>);
    _complete(): void;
}
