import Operator from '../Operator';
import Observer from '../Observer';
import Scheduler from '../Scheduler';
import Observable from '../Observable';
import Subscriber from '../Subscriber';
export default function observeOn<T>(scheduler: Scheduler, delay?: number): Observable<T>;
export declare class ObserveOnOperator<T, R> extends Operator<T, R> {
    delay: number;
    scheduler: Scheduler;
    constructor(scheduler: Scheduler, delay?: number);
    call(observer: Observer<T>): Observer<T>;
}
export declare class ObserveOnSubscriber<T> extends Subscriber<T> {
    static dispatch({type, value, destination}: {
        type: any;
        value: any;
        destination: any;
    }): void;
    delay: number;
    scheduler: Scheduler;
    constructor(destination: Observer<T>, scheduler: Scheduler, delay?: number);
    _next(x: any): void;
    _error(e: any): void;
    _complete(): void;
}
