import Operator from '../Operator';
import Observer from '../Observer';
import Subscriber from '../Subscriber';
import Observable from '../Observable';
import Subject from '../Subject';
import Subscription from '../Subscription';
export default function retryWhen<T>(notifier: (errors: Observable<any>) => Observable<any>): any;
export declare class RetryWhenOperator<T, R> extends Operator<T, R> {
    protected notifier: (errors: Observable<any>) => Observable<any>;
    protected original: Observable<T>;
    constructor(notifier: (errors: Observable<any>) => Observable<any>, original: Observable<T>);
    call(observer: Observer<T>): Observer<T>;
}
export declare class RetryWhenSubscriber<T> extends Subscriber<T> {
    notifier: (errors: Observable<any>) => Observable<any>;
    original: Observable<T>;
    errors: Subject<any>;
    retryNotifications: Observable<any>;
    retryNotificationSubscription: Subscription<any>;
    constructor(destination: Observer<T>, notifier: (errors: Observable<any>) => Observable<any>, original: Observable<T>);
    _error(err: any): void;
    finalError(err: any): void;
    resubscribe(): void;
}
export declare class RetryNotificationSubscriber<T> extends Subscriber<T> {
    parent: RetryWhenSubscriber<any>;
    constructor(parent: RetryWhenSubscriber<any>);
    _next(value: T): void;
    _error(err: any): void;
    _complete(): void;
}
