import Observer from '../Observer';
import Observable from '../Observable';
import Subscription from '../Subscription';
import { FlatMapOperator, FlatMapSubscriber } from './flatMap';
export default function switchLatest<T, R>(project: (x: T, ix: number) => Observable<any>, projectResult?: (x: T, y: any, ix: number, iy: number) => R): any;
export declare class SwitchLatestOperator<T, R> extends FlatMapOperator<T, R> {
    constructor(project: (x: T, ix: number) => Observable<any>, projectResult?: (x: T, y: any, ix: number, iy: number) => R);
    call(observer: Observer<R>): Observer<T>;
}
export declare class SwitchLatestSubscriber<T, R> extends FlatMapSubscriber<T, R> {
    innerSubscription: Subscription<T>;
    constructor(destination: Observer<R>, project: (x: T, ix: number) => Observable<any>, projectResult?: (x: T, y: any, ix: number, iy: number) => R);
    _buffer(value: any): void;
    _subscribeInner(observable: any, value: any, index: any): any;
}
