var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var flatMap_1 = require('./flatMap');
function switchLatest(project, projectResult) {
    return this.lift(new SwitchLatestOperator(project, projectResult));
}
exports.default = switchLatest;
var SwitchLatestOperator = (function (_super) {
    __extends(SwitchLatestOperator, _super);
    function SwitchLatestOperator(project, projectResult) {
        _super.call(this, project, projectResult, 1);
    }
    SwitchLatestOperator.prototype.call = function (observer) {
        return new SwitchLatestSubscriber(observer, this.project, this.projectResult);
    };
    return SwitchLatestOperator;
})(flatMap_1.FlatMapOperator);
exports.SwitchLatestOperator = SwitchLatestOperator;
var SwitchLatestSubscriber = (function (_super) {
    __extends(SwitchLatestSubscriber, _super);
    function SwitchLatestSubscriber(destination, project, projectResult) {
        _super.call(this, destination, 1, project, projectResult);
    }
    SwitchLatestSubscriber.prototype._buffer = function (value) {
        var active = this.active;
        if (active > 0) {
            this.active = active - 1;
            var inner = this.innerSubscription;
            if (inner) {
                inner.unsubscribe();
            }
        }
        this._next(value);
    };
    SwitchLatestSubscriber.prototype._subscribeInner = function (observable, value, index) {
        return (this.innerSubscription = _super.prototype._subscribeInner.call(this, observable, value, index));
    };
    return SwitchLatestSubscriber;
})(flatMap_1.FlatMapSubscriber);
exports.SwitchLatestSubscriber = SwitchLatestSubscriber;
